/*
** ioctl.c
**
** Jul/93:5
** Aug/93:3/4/10/20/24/25/26/30/31
** Sep/93:1/14
** Okt/93:7
*/

#include "atarierr.h"
#include "pty.h"
#include "sys/ptyio.h"


#if 1
#define AUSGABE
#endif


long pty_ioctl(FILEPTR *f, _wORD mode, void *buf)
{
	long cnt;
	struct Terminal *term = &terms[pty_nr];
	int ret;

	DEBUG("pty_ioctl %04x", (unsigned)mode);

	switch(mode)
	{
	case FIONREAD:
		READCNT_PTY(cnt, term);
		*((long *)buf) = cnt;
#ifdef AUSGABE
		DEBUG("pty_ioctl: FIONREAD %08lx", cnt);
#endif
		break;
	case FIONWRITE:
		WRITECNT_PTY(cnt, term);
		*((long *)buf) = cnt;
#ifdef AUSGABE
		DEBUG("pty_ioctl: FIONWRITE %08lx", cnt);
#endif
		break;
	case TIOCSIGSEND:
#ifdef AUSGABE
		DEBUG("pty_ioctl: TIOCSIGSEND");
#endif

		if(((struct tty *)f->devinfo)->pgrp <= 0)
		{
			DEBUG("pty_ioctl: pgrp <= 0");
			return(ERROR);
		}

		ret = PKILL((short)((struct tty *)f->devinfo)->pgrp, (short)(long)buf);
		if(ret == ERANGE)
		{
			ret = EINVAL;
		}
		return(ret);
		break;
	case TIOCTTY:
#ifdef AUSGABE
		DEBUG("pty_ioctl: TIOCTTY");
#endif

		/* XXX: flush */
/*		pty->pty->ist_ctty = pty->ist_ctty = *((int *)buf);*/
		/* XXX: unblock(read) */
		break;
	case TIOCPKT:
#ifdef AUSGABE
		DEBUG("pty_ioctl: TIOCPKT");
#endif
/*		pty->pty->ist_cpkt = pty->ist_cpkt = *((int *)buf);*/
/*		pty->cpkt_status = TIOCPKT_DATA;*/
		break;
	case TIOCREMOTE:
	case TIOCBREAK:
	case TIOCSTOP:
	case TIOCSTART:
	case TIOCTRAP:
	case TIOCTRAPSTATUS:
	case TIOCREQCHECK:
	case TIOCREQGET:
	case TIOCREQSET:
	case TIOCMONITOR:
	case TIOCSIGMODE:
		DEBUG("pty_ioctl: %04x not implemented", (unsigned)mode);
		return(EINVFN);
		break;
	default:
		DEBUG("pty_ioctl: wrong ioctl: f = %08lx, mode = %04x, buf = %08lx", (long)f, (unsigned)mode, (long)buf);
		return(EINVAL);
		break;
	}

	return(E_OK);
}

long tty_ioctl(FILEPTR *f, _wORD mode, void *buf)
{
	long cnt;
	struct Terminal *term = &terms[pty_nr];

	DEBUG("tty_ioctl %04x", (unsigned)mode);

	if(term->pty_open == 0)
	{
		return(EIO);	/* Master nicht geoeffnet */
	}

	switch(mode)
	{
	case FIONREAD:
		READCNT_TTY(cnt, term);
		*((long *)buf) = cnt;
#ifdef AUSGABE
		DEBUG("tty_ioctl: FIONREAD %08lx", cnt);
#endif
		break;
	case FIONWRITE:
		WRITECNT_TTY(cnt, term);
		*((long *)buf) = cnt;
#ifdef AUSGABE
		DEBUG("tty_ioctl: FIONWRITE %08lx", cnt);
#endif
		break;
	default:
		DEBUG("tty_ioctl: wrong ioctl: f = %08lx, mode = %04x, buf = %08lx", (long)f, (unsigned)mode, (long)buf);
		return(EINVAL);
		break;
	}

	return(E_OK);
}
