/*
** open.c
**
** Jul/93:5/9
** Aug/93:3/4/20/24/25/26
** Sep/93:1/21
** Okt/93:7/11
*/

#include "atarierr.h"
#include "pty.h"
#include "sys/ptyio.h"


long pty_open(FILEPTR *f)
{
	struct Terminal *term = &terms[pty_nr];

	TRACE("pty_open");

	if(term->pty_open > 0)
	{
		DEBUG("pty_open: pty is already open");
		return(EBUSY);
	}

	if(term->tty_open > 0)
	{
		DEBUG("pty_open: tty is open");
		return(EBUSY);
	}

	term->p2t_rd = term->p2t_wr = term->p2t_buf;
	term->t2p_rd = term->t2p_wr = term->t2p_buf;
	term->pty_open = 1;
/*	term->ist_ctty = 1;*/
/*	term->ist_cpkt = 0;*/
/*	term->cpkt_status = TIOCPKT_DATA;*/

	f->flags |= O_TTY|O_HEAD;	/* pty (tty+master) */
	f->flags |= O_NDELAY;		/* XXX: sollt nicht noetig sein (fuer xterm) */

	return(E_OK);
}

long tty_open(FILEPTR *f)
{
	struct Terminal *term = &terms[pty_nr];

	TRACE("tty_open");

	if(term->tty_open > 0)
	{
/*		DEBUG("tty_open: tty is open");*/
/*		return(EACCDN);*/
	}
	else
	{
		if(term->pty_open == 0)	/* zugehoeriger pty nicht offen? */
		{
			if((f->flags&O_NDELAY) == 0)	/* nicht warten? */
			{
				DEBUG("tty_open: pty is not open (O_NDELAY)");
				return(ERROR);	/* --> Fehler */
			}
			else
			{
				DEBUG("tty_open: pty is not open (!O_NDELAY)");
#if 0
				/* XXX: warten bis pty geoeffnet wird */
#else
				return(EBUSY); /* XXX: kein Fehler! (s.o.) */
#endif
			}
		}
	}

	term->tty_open = 1;
/*	term->ist_ctty = 1;*/
/*	term->ist_cpkt = 0;*/
/*	term->cpkt_status = TIOCPKT_DATA;*/

	f->flags |= O_TTY;		/* tty */

	return(E_OK);
}
