/*
** pty-hilf.c
**
** Aug/93:31
** Sep/93:1/14
** Okt/93:7/11
** Mrz/94:22
*/

#include "proc.h" /* IO_Q */
#include "pty-hilf.h"


#if 1
#define AUSGABE
#endif


#define READ_PTY_OFFSET 0
#define READ_TTY_OFFSET 1
#define WRITE_PTY_OFFSET 2
#define WRITE_TTY_OFFSET 3


void term_wake(struct Terminal *term, int art)
{
	if(art&READ_PTY)
	{
#ifdef AUSGABE
		DEBUG("term_wake %08lx READpty", (long)term);
#endif
		wake(IO_Q, (long)term+READ_PTY_OFFSET);
		if(term->pty_tty.rsel != 0)
		{
			wakeselect(term->pty_tty.rsel);
			term->pty_tty.rsel = 0;
		}
	}
	if(art&READ_TTY)
	{
#ifdef AUSGABE
		DEBUG("term_wake %08lx READtty", (long)term);
#endif
		wake(IO_Q, (long)term+READ_TTY_OFFSET);
		if(term->tty_tty.rsel != 0)
		{
			wakeselect(term->tty_tty.rsel);
			term->tty_tty.rsel = 0;
		}
	}
	if(art&WRITE_PTY)
	{
#ifdef AUSGABE
		DEBUG("term_wake %08lx WRITEpty", (long)term);
#endif
		wake(IO_Q, (long)term+WRITE_PTY_OFFSET);
		if(term->pty_tty.wsel != 0)
		{
			wakeselect(term->pty_tty.wsel);
			term->pty_tty.wsel = 0;
		}
	}
	if(art&WRITE_TTY)
	{
#ifdef AUSGABE
		DEBUG("term_wake %08lx WRITEtty", (long)term);
#endif
		wake(IO_Q, (long)term+WRITE_TTY_OFFSET);
		if(term->tty_tty.wsel != 0)
		{
			wakeselect(term->tty_tty.wsel);
			term->tty_tty.wsel = 0;
		}
	}
}

void term_sleep(struct Terminal *term, int art)
{
	switch(art)
	{
	case READ_PTY:
#ifdef AUSGABE
		DEBUG("term_sleep %08lx READpty", (long)term);
#endif
		sleep(IO_Q, (long)term+READ_PTY_OFFSET);
		break;
	case READ_TTY:
#ifdef AUSGABE
		DEBUG("term_sleep %08lx READtty", (long)term);
#endif
		sleep(IO_Q, (long)term+READ_TTY_OFFSET);
		break;
	case WRITE_PTY:
#ifdef AUSGABE
		DEBUG("term_sleep %08lx WRITEpty", (long)term);
#endif
		sleep(IO_Q, (long)term+WRITE_PTY_OFFSET);
		break;
	case WRITE_TTY:
#ifdef AUSGABE
		DEBUG("term_sleep %08lx WRITEtty", (long)term);
#endif
		sleep(IO_Q, (long)term+WRITE_TTY_OFFSET);
		break;
	default:
		DEBUG("term_sleep: wrong arg");
		break;
	}
}
