/*
** pty.c
**
** Aug/93:24
** Okt/93:7/21
** Mrz/94:22
** Apr/94:11
*/

#include <basepage.h>
#include <mintbind.h>
#include <osbind.h>
#include <stddef.h>
#include <string.h>

#include "pty.h"


#if 0
#define TEST
#endif


#define MAX_PTY 2			/* Anzahl der ptys */


#define PTY_DEVNAME "u:\\dev\\pty"	/* Treiber-Name (Anfang) */
#define TTY_DEVNAME "u:\\dev\\tty"	/* Treiber-Name (Anfang) */
#define UWORD unsigned short


#define BP _base


struct Terminal terms[MAX_PTY];


long _stksize = 8192;


void main()
{
	char pty_puffer[256];		/* allgemeiner Ausgabepuffer */
	char tty_puffer[256];
	int i;
	int ptypos;
	int max_pty = MAX_PTY;

#ifdef TEST
	Cconws("pty-main\r\n");
#endif

	if(max_pty > (&pty_e-&pty_0)/(&pty_1-&pty_0))
	{
		Cconws("MAX_PTY in " __FILE__ " is too big (has been corrected)\r\n"); 
		max_pty = (&pty_e-&pty_0)/(&pty_1-&pty_0);
	}
#ifdef TEST
	Cconws("max_pty ok\r\n");
#endif

	if(&pty_1-&pty_0 != 72)
	{
#if 1
		Cconws("&pty_1-&pty_0 false\r\n");
#else
		sprintf(pty_puffer, "&pty_1-&pty_0 false (%d, should be 72) (in " __FILE__ ")\r\n", (int)(&pty_1-&pty_0));
		Cconws(pty_puffer);
#endif
		Pterm(0);
	}
#ifdef TEST
	Cconws("pty_X ok\r\n");
#endif

	ptypos = 0;
	for(i = 0; i < max_pty && ptypos < 22*16; i++)
	{
		struct kerinfo *kerinfo1, *kerinfo2;

#ifdef TEST
		Cconws("for pty\r\n");
#endif

		for(;;)
		{
			char ext[3];
			XATTR xattr;

			ext[0] = "pqrstuvwxyzPQRSTUVWXYZ"[ptypos/16];
			ext[1] = "0123456789abcdef"[ptypos%16];
			ext[2] = '\0';

			ptypos++;
			if(ptypos >= 22*16)
			{
				Cconws("no more free ptys\r\n");
				break;
			}

#ifdef TEST
			Cconws("for pty (2)\r\n");
#endif
			strcpy(pty_puffer, PTY_DEVNAME);
			strcpy(pty_puffer+sizeof(PTY_DEVNAME)-1, ext);
			strcpy(tty_puffer, TTY_DEVNAME);
			strcpy(tty_puffer+sizeof(TTY_DEVNAME)-1, ext);

#ifdef TEST
			Cconws("for pty (3:");
			Cconws(pty_puffer);
			Cconws("/");
			Cconws(tty_puffer);
			Cconws(")\r\n");
#endif
			if(Fxattr(1, pty_puffer, &xattr) == -33
			&& Fxattr(1, tty_puffer, &xattr) == -33)
			{
#ifdef TEST
				Cconws("for pty: Fxattr ok\r\n");
#endif
				break;
			}

#ifdef TEST
			Cconws("for pty: Fxattr ko\r\n");
#endif
		}

		terms[i].tty_open = terms[i].pty_open = 0;
		terms[i].t2p_rd = terms[i].t2p_wr = terms[i].t2p_buf;
		terms[i].p2t_rd = terms[i].p2t_wr = terms[i].p2t_buf;

		terms[i].pty_driver.open = (long (*)(FILEPTR *))&pty_0+(&pty_1-&pty_0)*i+0;
		terms[i].tty_driver.open = (long (*)(FILEPTR *))&pty_0+(&pty_1-&pty_0)*i+4;
		terms[i].pty_driver.write = (long (*)(FILEPTR *, char *, long))&pty_0+(&pty_1-&pty_0)*i+8;
		terms[i].tty_driver.write = (long (*)(FILEPTR *, char *, long))&pty_0+(&pty_1-&pty_0)*i+12;
		terms[i].pty_driver.read = (long (*)(FILEPTR *, char *, long))&pty_0+(&pty_1-&pty_0)*i+16;
		terms[i].tty_driver.read = (long (*)(FILEPTR *, char *, long))&pty_0+(&pty_1-&pty_0)*i+20;
		terms[i].pty_driver.lseek = (long (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+24;
		terms[i].tty_driver.lseek = (long (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+28;
		terms[i].pty_driver.ioctl = (long (*)(FILEPTR *, _wORD, void *))&pty_0+(&pty_1-&pty_0)*i+32;
		terms[i].tty_driver.ioctl = (long (*)(FILEPTR *, _wORD, void *))&pty_0+(&pty_1-&pty_0)*i+36;
		terms[i].pty_driver.datime = (long (*)(FILEPTR *, _wORD *, _wORD))&pty_0+(&pty_1-&pty_0)*i+40;
		terms[i].tty_driver.datime = (long (*)(FILEPTR *, _wORD *, _wORD))&pty_0+(&pty_1-&pty_0)*i+44;
		terms[i].pty_driver.close = (long (*)(FILEPTR *))&pty_0+(&pty_1-&pty_0)*i+48;
		terms[i].tty_driver.close = (long (*)(FILEPTR *))&pty_0+(&pty_1-&pty_0)*i+52;
		terms[i].pty_driver.select = (long (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+56;
		terms[i].tty_driver.select = (long (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+60;
		terms[i].pty_driver.unselect = (void (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+64;
		terms[i].tty_driver.unselect = (void (*)(FILEPTR *, long, _wORD))&pty_0+(&pty_1-&pty_0)*i+68;

#if 1
		memset(&terms[i].pty_device, 0, sizeof(terms[i].pty_device));
		memset(&terms[i].tty_device, 0, sizeof(terms[i].tty_device));
		terms[i].pty_device.driver = &terms[i].pty_driver;
		terms[i].tty_device.driver = &terms[i].tty_driver;
		terms[i].pty_device.dinfo = 0;
		terms[i].tty_device.dinfo = 0;
		terms[i].pty_device.flags = O_TTY|O_HEAD;
		terms[i].tty_device.flags = O_TTY;
		terms[i].pty_device.tty = &terms[i].pty_tty;
		terms[i].tty_device.tty = &terms[i].tty_tty;
#else
		terms[i].pty_device.driver = &terms[i].pty_driver;
		terms[i].tty_device.driver = &terms[i].tty_driver;
		terms[i].pty_device.dinfo = 0;
		terms[i].tty_device.dinfo = 0;
		terms[i].pty_device.flags = O_TTY|O_HEAD;
		terms[i].tty_device.flags = O_TTY;
		terms[i].pty_device.tty = &terms[i].pty_tty;
		terms[i].tty_device.tty = &terms[i].tty_tty;
		terms[i].pty_device.reserved[0] = 0;
		terms[i].tty_device.reserved[0] = 0;
		terms[i].pty_device.reserved[1] = 0;
		terms[i].tty_device.reserved[1] = 0;
		terms[i].pty_device.reserved[2] = 0;
		terms[i].tty_device.reserved[2] = 0;
		terms[i].pty_device.reserved[3] = 0;
		terms[i].tty_device.reserved[3] = 0;
#endif

#if 1
		memset(&terms[i].pty_tty, 0, sizeof(terms[i].pty_tty));
		memset(&terms[i].tty_tty, 0, sizeof(terms[i].tty_tty));
#else
		terms[i].pty_tty.pgrp = 0;
		terms[i].tty_tty.pgrp = 0;
		terms[i].pty_tty.state = 0;
		terms[i].tty_tty.state = 0;
		terms[i].pty_tty.use_cnt = 0;
		terms[i].tty_tty.use_cnt = 0;
		terms[i].pty_tty.res1 = 0;
		terms[i].tty_tty.res1 = 0;
		terms[i].pty_tty.sg.sg_ispeed = 0;
		terms[i].tty_tty.sg.sg_ispeed = 0;
		terms[i].pty_tty.sg.sg_ospeed = 0;
		terms[i].tty_tty.sg.sg_ospeed = 0;
		terms[i].pty_tty.sg.sg_erase = 0;
		terms[i].tty_tty.sg.sg_erase = 0;
		terms[i].pty_tty.sg.sg_kill = 0;
		terms[i].tty_tty.sg.sg_kill = 0;
		terms[i].pty_tty.sg.sg_flags = 0;
		terms[i].tty_tty.sg.sg_flags = 0;
		terms[i].pty_tty.tc.t_intrc = 0;
		terms[i].tty_tty.tc.t_intrc = 0;
		terms[i].pty_tty.tc.t_quitc = 0;
		terms[i].tty_tty.tc.t_quitc = 0;
		terms[i].pty_tty.tc.t_startc = 0;
		terms[i].tty_tty.tc.t_startc = 0;
		terms[i].pty_tty.tc.t_stopc = 0;
		terms[i].tty_tty.tc.t_stopc = 0;
		terms[i].pty_tty.tc.t_eofc = 0;
		terms[i].tty_tty.tc.t_eofc = 0;
		terms[i].pty_tty.tc.t_brkc = 0;
		terms[i].tty_tty.tc.t_brkc = 0;
		terms[i].pty_tty.ltc.t_suspc = 0;
		terms[i].tty_tty.ltc.t_suspc = 0;
		terms[i].pty_tty.ltc.t_dsuspc = 0;
		terms[i].tty_tty.ltc.t_dsuspc = 0;
		terms[i].pty_tty.ltc.t_rprntc = 0;
		terms[i].tty_tty.ltc.t_rprntc = 0;
		terms[i].pty_tty.ltc.t_flushc = 0;
		terms[i].tty_tty.ltc.t_flushc = 0;
		terms[i].pty_tty.ltc.t_werasc = 0;
		terms[i].tty_tty.ltc.t_werasc = 0;
		terms[i].pty_tty.ltc.t_lnextc = 0;
		terms[i].tty_tty.ltc.t_lnextc = 0;
		terms[i].pty_tty.wsiz.ws_row = 0;
		terms[i].tty_tty.wsiz.ws_row = 0;
		terms[i].pty_tty.wsiz.ws_col = 0;
		terms[i].tty_tty.wsiz.ws_col = 0;
		terms[i].pty_tty.wsiz.ws_xpixel = 0;
		terms[i].tty_tty.wsiz.ws_xpixel = 0;
		terms[i].pty_tty.wsiz.ws_ypixel = 0;
		terms[i].tty_tty.wsiz.ws_ypixel = 0;
		terms[i].pty_tty.rsel = 0;
		terms[i].tty_tty.rsel = 0;
		terms[i].pty_tty.wsel = 0;
		terms[i].tty_tty.wsel = 0;
		terms[i].pty_tty.rsrvd[0] = 0;
		terms[i].tty_tty.rsrvd[0] = 0;
		terms[i].pty_tty.rsrvd[1] = 0;
		terms[i].tty_tty.rsrvd[1] = 0;
		terms[i].pty_tty.rsrvd[2] = 0;
		terms[i].tty_tty.rsrvd[2] = 0;
		terms[i].pty_tty.rsrvd[3] = 0;
		terms[i].tty_tty.rsrvd[3] = 0;
#endif

#ifdef TEST
		Cconws("for pty: vor DEV_INSTALL\r\n");
#endif
		kerinfo1 = (struct kerinfo *)Dcntl(DEV_INSTALL, pty_puffer, &terms[i].pty_device);
		kerinfo2 = (struct kerinfo *)Dcntl(DEV_INSTALL, tty_puffer, &terms[i].tty_device);
		if(kerinfo1 == NULL || ((long)kerinfo1) == -32
		|| kerinfo2 == NULL || ((long)kerinfo2) == -32)
		{
			Cconws("Unable to install ");
			Cconws(pty_puffer);
			Cconws(" and ");
			Cconws(tty_puffer);
			Cconws("\r\n");

			/* XXX: pty inst, tty nicht inst */

			break;
		}

#ifdef TEST
		Cconws("for pty: DEV_INSTALL ok\r\n");
#endif

		if(i == 0)
		{
			kerinfo = kerinfo1;
		}
		if(kerinfo1 != kerinfo2 || kerinfo != kerinfo1)
		{
			Cconws("Warnung: kerinfo unterschiedlich\r\n");
		}
#ifdef TEST
		Cconws("for pty: end\r\n");
#endif
	}

#if 1
	pty_puffer[0] = (i/100)%10+'0';
	pty_puffer[1] = (i/10)%10+'0';
	pty_puffer[2] = i%10+'0';
	strcpy(pty_puffer+3, " ptys installed\r\n");
#else
	sprintf(pty_puffer, "%d%s", ptypos, " ptys installed\r\n");
#endif
	Cconws(pty_puffer);

	if(i > 0)
	{
		Ptermres(256L+BP->p_tlen+BP->p_dlen+BP->p_blen, 0);
	}
	Pterm(0);
}
