/*
** pty.h
**
** Aug/93:24/25/26/30/31
** Sep/93:21
** Okt/93:7
*/

#ifndef PTY_H
#define PTY_H

#include "filesys.h"


/* XXX: fehlen in atarierr.h bzw filesys.h */
#define EBUSY EACCDN
#define EIO ERROR
#define EINVAL EINVFN

#define TIOCSIGSEND	(('T'<<8)|128)
#define TIOCTTY		(('T'<<8)|129)
/*#define TIOCPKT	(('T'<<8)|130)*/	/* in sys/ptyio.h */
#define TIOCREMOTE	(('T'<<8)|131)
#define TIOCBREAK	(('T'<<8)|132)
/*#define TIOCSTOP	(('T'<<8)|133)*/
/*#define TIOCSTART	(('T'<<8)|134)*/
#define TIOCTRAP	(('T'<<8)|135)
#define TIOCTRAPSTATUS	(('T'<<8)|136)
#define TIOCREQCHECK	(('T'<<8)|137)
#define TIOCREQGET	(('T'<<8)|138)
#define TIOCREQSET	(('T'<<8)|139)
#define TIOCMONITOR	(('T'<<8)|140)
#define TIOCSIGMODE	(('T'<<8)|141)


extern char pty_0, pty_1, pty_e;

extern short pty_nr;	/* Nummer des aufgerufenen PTYs */

struct kerinfo *kerinfo;

struct Terminal
{
	int tty_open;			/* 0 = tty ist nicht geoeffnet; sonst Anzahl */
	int pty_open;			/* 0 = pty ist nicht geoeffnet; sonst Anzahl */
/*	int ist_ctty;*/			/* 0 = TIOCTTY aus [Master] */
/*	int ist_cpkt;*/			/* 0 = TIOCPKT aus [Master] */
/*	int cpkt_status;*/		/* Status bei ist_cpkt != 0 [Master] */
	DEVDRV tty_driver, pty_driver;
	struct dev_descr tty_device, pty_device;
	struct tty tty_tty, pty_tty;
	char *t2p_rd, *p2t_rd;		/* Lesezeiger in buf */
	char *t2p_wr, *p2t_wr;		/* Schreibzeiger in buf */
	char t2p_buf[4096+1], p2t_buf[4096+1];	/* Puffer (min 256+1 gross) (leer, falls rd == wr) (muessen nicht gleich gross sein) */
};

extern struct Terminal terms[];


#define READCNT_PTY(cnt, term)\
{\
	cnt = term->t2p_wr-term->t2p_rd;\
	if(cnt < 0)\
	{\
		cnt += sizeof(term->t2p_buf);\
	}\
}

#define WRITECNT_PTY(cnt, term)\
{\
	cnt = term->p2t_rd-term->p2t_wr-1;\
	if(cnt < 0)\
	{\
		cnt += sizeof(term->p2t_buf);\
	}\
}

#define READCNT_TTY(cnt, term)\
{\
	cnt = term->p2t_wr-term->p2t_rd;\
	if(cnt < 0)\
	{\
		cnt += sizeof(term->p2t_buf);\
	}\
}

#define WRITECNT_TTY(cnt, term)\
{\
	cnt = term->t2p_rd-term->t2p_wr-1;\
	if(cnt < 0)\
	{\
		cnt += sizeof(term->t2p_buf);\
	}\
}


long pty_open P_((FILEPTR *f));
long tty_open P_((FILEPTR *f));
long pty_write P_((FILEPTR *f, char *buf, long bytes));
long tty_write P_((FILEPTR *f, char *buf, long bytes));
long pty_read P_((FILEPTR *f, char *buf, long bytes));
long tty_read P_((FILEPTR *f, char *buf, long bytes));
long pty_lseek P_((FILEPTR *f, long where, _wORD whence));
long tty_lseek P_((FILEPTR *f, long where, _wORD whence));
long pty_ioctl P_((FILEPTR *f, _wORD mode, void *buf));
long tty_ioctl P_((FILEPTR *f, _wORD mode, void *buf));
long pty_datime P_((FILEPTR *f, _wORD *timeptr, _wORD rwflag));
long tty_datime P_((FILEPTR *f, _wORD *timeptr, _wORD rwflag));
long pty_close P_((FILEPTR *f));
long tty_close P_((FILEPTR *f));
long pty_select P_((FILEPTR *f, long proc, _wORD mode));
long tty_select P_((FILEPTR *f, long proc, _wORD mode));
void pty_unselect P_((FILEPTR *f, long proc, _wORD mode));
void tty_unselect P_((FILEPTR *f, long proc, _wORD mode));


#define CCONWS		(*kerinfo->dos_tab[0x009])
#define TGETTIME	(*kerinfo->dos_tab[0x02c])
#define TGETDATE	(*kerinfo->dos_tab[0x02a])
#define PKILL		(*kerinfo->dos_tab[0x111])

#define wake		(*kerinfo->wake)
#define sleep		(*kerinfo->sleep)
#define wakeselect	(*kerinfo->wakeselect)

#define SPRINTF (*kerinfo->sprintf)
#define DEBUG (*kerinfo->debug)
#define ALERT (*kerinfo->alert)
#define TRACE (*kerinfo->trace)
#define FATAL (*kerinfo->fatal)

#endif
