/*
** read.c
**
** Jul/93:5/9
** Aug/93:3/4/10/20/24/25/26/30/31
** Sep/93:1/9/14/21
** Okt/93:7/11
** Nov/94:2
*/

#include "atarierr.h"
#include "pty.h"
#include "pty-hilf.h"
#include "sys/ptyio.h"


#if 0
#define AUSGABE
#endif


long pty_read(FILEPTR *f, char *buf, long bytes)
{
	struct Terminal *term = &terms[pty_nr];
	struct tty *tty = (struct tty *)f->devinfo;
	long cnt;
	int block;

#ifdef AUSGABE
	DEBUG("pty_read %ld --> %08lx", bytes, (long)buf);
#endif

	block = (f->flags&O_NDELAY) != O_NDELAY /*&& !pty->ist_ctty*/;

#if 0
	if(term->ist_cpkt)
	{
		*buf++ = pty->cpkt_status;
		pty->cpkt_status = TIOCPKT_DATA;
	}
#endif

	for(;;)
	{
		READCNT_PTY(cnt, term);
		if(cnt < 0)
		{
			DEBUG("pty_read: cnt < 0");
			return(ERROR);
		}
		if(cnt > 0) /* Puffer belegt? */
		{
			break;
		}
		if(bytes <= 0) /* nichts lesen? */
		{
			break;
		}

		/* Puffer leer */
		if(!block)
		{
#ifdef AUSGABE
			DEBUG("pty_read: return 0 (O_NDELAY...)");
#endif
			return(0);
		}

		term_sleep(term, READ_PTY); /* auf Daten warten */
	}

	if(cnt > bytes)
	{
		cnt = bytes;
	}
	bytes = cnt;
	while(bytes > 0)
	{
		*buf++ = *term->t2p_rd++;
		if(term->t2p_rd >= &term->t2p_buf[sizeof(term->t2p_buf)])
		{
			term->t2p_rd = term->t2p_buf;
		}
		bytes--;
	}

	term_wake(term, WRITE_TTY);
	if(tty->wsel && cnt > 0)
	{
		wakeselect(tty->wsel);
		tty->wsel = 0;
	}

#ifdef AUSGABE
	DEBUG("pty_read: return %ld", cnt);
#endif

	return(cnt);
}

long tty_read(FILEPTR *f, char *buf, long bytes)
{
	struct Terminal *term = &terms[pty_nr];
	struct tty *tty = (struct tty *)f->devinfo;
	long cnt;
	int block;

#ifdef AUSGABE
	DEBUG("tty_read %ld --> %08lx", bytes, (long)buf);
#endif

	block = (f->flags&O_NDELAY) != O_NDELAY /*&& !pty->ist_ctty*/;

	for(;;)
	{
		READCNT_TTY(cnt, term);
		if(cnt < 0)
		{
			DEBUG("tty_read: cnt < 0");
			return(ERROR);
		}
		if(cnt > 0) /* Puffer belegt? */
		{
			break;
		}
		if(bytes <= 0) /* nichts lesen? */
		{
			break;
		}

		/* Puffer leer */
		if(term->pty_open == 0) /* pty nicht geoeffnet? */
		{
			return(EIO); /* XXX: welche Fehlermeldung??? */
		}

		if(!block)
		{
#ifdef AUSGABE
			DEBUG("tty_read: return 0 (O_NDELAY...)");
#endif
			return(0);
		}

		term_sleep(term, READ_TTY); /* auf Daten warten */
	}

	if(cnt > bytes)
	{
		cnt = bytes;
	}
	bytes = cnt;
	while(bytes > 0)
	{
		*buf++ = *term->p2t_rd++;
		if(term->p2t_rd >= &term->p2t_buf[sizeof(term->p2t_buf)])
		{
			term->p2t_rd = term->p2t_buf;
		}
		bytes--;
	}

	term_wake(term, WRITE_PTY);
	if(tty->wsel && cnt > 0)
	{
		wakeselect(tty->wsel);
		tty->wsel = 0;
	}

#ifdef AUSGABE
	DEBUG("tty_read: return %ld", cnt);
#endif

	return(cnt);
}
