/*
** write.c
**
** Jul/93:5
** Aug/93:3/4/20/24/25/30/31
** Sep/93:14/21
** Okt/93:7/11
** Nov/94:2
*/

#include "atarierr.h"
#include "pty.h"
#include "pty-hilf.h"


#if 0
#define AUSGABE
#endif


long pty_write P_((FILEPTR *f, char *buf, long bytes))
{
	struct Terminal *term = &terms[pty_nr];
	struct tty *tty = (struct tty *)f->devinfo;
	long zwsp = 0;
	int block;

#ifdef AUSGABE
	DEBUG("pty_write %ld --> %08lx", bytes, (long)buf);
#endif

	block = (f->flags&O_NDELAY) != O_NDELAY /*&& !pty->ist_ctty*/;

	while(bytes > 0)
	{
		long cnt;

		WRITECNT_PTY(cnt, term);
		if(cnt < 0)
		{
			DEBUG("pty_write: cnt < 0");
			return(ERROR);
		}
		if(cnt > 0) /* Puffer frei? */
		{
			while(cnt > 0 && bytes > 0)
			{
#ifdef AUSGABE
				DEBUG("pty_write(%02x)", (unsigned)(unsigned char)*buf);
#endif

				*term->p2t_wr++ = *buf++;
				if(term->p2t_wr >= &term->p2t_buf[sizeof(term->p2t_buf)])
				{
					term->p2t_wr = term->p2t_buf;
				}
				cnt--;
				bytes--;
				zwsp++;
			}

			term_wake(term, READ_TTY);
			if(tty->rsel)
			{
				wakeselect(tty->rsel);
				tty->rsel = 0;
			}
		}
		if(bytes > 0)
		{
			if(!block)
			{
				break;
			}

#if defined(AUSGABE)
			DEBUG("");
			DEBUG("pty_sleep (bytes = %ld, cnt = %ld)", bytes, cnt);
			DEBUG("pty->tty = %08lx (rd = %08lx, wr = %08lx, buf = %08lx, sizeof = %lu)", (long)term, term->p2t_rd, term->t2p_wr, term->t2p_buf, sizeof(term->t2p_buf));
			DEBUG("tty->pty = %08lx (rd = %08lx, wr = %08lx, buf = %08lx, sizeof = %lu)", (long)term, term->t2p_rd, term->p2t_wr, term->p2t_buf, sizeof(term->p2t_buf));
#endif

			term_sleep(term, WRITE_PTY);
		}
	}

#ifdef AUSGABE
	DEBUG("pty_write: return %ld", zwsp);
#endif

	return(zwsp);
}

long tty_write P_((FILEPTR *f, char *buf, long bytes))
{
	struct Terminal *term = &terms[pty_nr];
	struct tty *tty = (struct tty *)f->devinfo;
	long zwsp = 0;
	int block;

#ifdef AUSGABE
	DEBUG("tty_write %ld --> %08lx", bytes, (long)buf);
#endif

	block = (f->flags&O_NDELAY) != O_NDELAY /*&& !pty->ist_ctty*/;

	while(bytes > 0)
	{
		long cnt;

		if(term->pty_open == 0) /* pty nicht geoeffnet? */
		{
			return(EIO); /* XXX: welche Fehlemeldung? */
		}

		WRITECNT_TTY(cnt, term);
		if(cnt < 0)
		{
			DEBUG("tty_write: cnt < 0");
			return(ERROR);
		}
		if(cnt > 0) /* Puffer frei? */
		{
			while(cnt > 0 && bytes > 0)
			{
#ifdef AUSGABE
				DEBUG("tty_write(%02x)", (unsigned)(unsigned char)*buf);
#endif

				*term->t2p_wr++ = *buf++;
				if(term->t2p_wr >= &term->t2p_buf[sizeof(term->t2p_buf)])
				{
					term->t2p_wr = term->t2p_buf;
				}
				cnt--;
				bytes--;
				zwsp++;
			}

			term_wake(term, READ_PTY);
			if(tty->rsel)
			{
				wakeselect(tty->rsel);
				tty->rsel = 0;
			}
		}
		if(bytes > 0)
		{
			if(!block)
			{
				break;
			}

#if defined(AUSGABE)
			DEBUG("");
			DEBUG("tty_sleep (bytes = %ld, cnt = %ld)", bytes, cnt);
			DEBUG("pty->tty = %08lx (rd = %08lx, wr = %08lx, buf = %08lx, sizeof = %lu)", (long)term, term->p2t_rd, term->t2p_wr, term->t2p_buf, sizeof(term->t2p_buf));
			DEBUG("tty->pty = %08lx (rd = %08lx, wr = %08lx, buf = %08lx, sizeof = %lu)", (long)term, term->t2p_rd, term->p2t_wr, term->p2t_buf, sizeof(term->p2t_buf));
#endif

			term_sleep(term, WRITE_TTY);
		}
	}

#ifdef AUSGABE
	DEBUG("tty_write: return %ld", zwsp);
#endif

	return(zwsp);
}
